Imports System.Xml.Serialization

Public Class Form1

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim num_desserts&
        Dim satisfaction_quotient#
        num_desserts = 100
        satisfaction_quotient# = 1.23

        Dim an_integer As Integer = 100
        Dim a_long As Long = 10000000000
        Dim a_double As Double = 1.0

        Dim a_boolean As Boolean = True
        Dim a_date As Date = #12/31/2007#

        Dim i As Long = 123L
        Dim ch As Char = "X"c

        Dim flags As ULong
        flags = 100 ' Decimal 100.
        flags = &H64 ' Hexadecimal &H64 = 6 * 16 + 4 = 96 + 4 = 100.
        flags = &O144 ' Octal &O144 = 1 * 8 * 8 + 4 * 8 + 4 = 64 + 32 + 4 = 100.

        Debug.WriteLine(flags)      ' Decimal.
        Debug.WriteLine(Hex(flags)) ' Hexadecimal.
        Debug.WriteLine(Oct(flags)) ' Octal.

    End Sub

    Private Sub Test()
        Dim ch As Char
        ch = "X" ' Error because X is a String.
        ch = "X"c ' Okay because Xc is a Char.
        Dim amount As Decimal
        amount = 12.34 ' Error because 12.34 is a Double.
        amount = 12.34D ' Okay because 12.34D is a Decimal.

        ch = CChar("X")
        amount = CDec(12.34)

        ' Narrowing conversion.
        Dim an_integer As Integer
        Dim a_long As Long
        ' ...
        an_integer = a_long

        'Dim an_integer As Integer
        Dim a_string As String
        ' ...
        an_integer = a_string

        Dim an_employee As Employee
        Dim a_person As Person
        ' ...
        an_employee = a_person

        'Dim an_integer As Integer
        Dim a_byte As Byte
        ' ...
        a_byte = CByte(an_integer)
    End Sub

    Private Sub Casting()
        Dim an_integer As Integer
        Dim a_long As Long = 100
        an_integer = CType(a_long, Integer)

        Dim dessert_obj As Object = New Dessert("Ice Cream")
        Dim my_dessert As Dessert
        my_dessert = DirectCast(dessert_obj, Dessert)

        'Dim an_integer As Integer = 100
        'Dim a_long As Long
        a_long = DirectCast(an_integer, Long)
    End Sub

    Public Sub Parsing()
        Dim txt_entered As String = "112358"
        Dim num_entered As Integer
        ' ...
        num_entered = CInt(txt_entered) ' Use CInt.
        num_entered = Integer.Parse(txt_entered) ' Use Integer.Parse.
    End Sub
End Class

Public Class Person

End Class

Public Class Employee
    Inherits Person
End Class

Public Class Dessert
    Public Sub New(ByVal name As String)

    End Sub
End Class

Public Class OrderItem
    <XmlText()> _
    Public ItemName As String

    <XmlAttributeAttribute(AttributeName:="Cost")> _
    Public Price As Decimal

    <XmlAttributeAttribute()> _
    Public Quantity As Integer
End Class
